package com.example.aped.ui.all_IOs;

import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import com.android.volley.Response;
import com.example.aped.MainActivity;
import com.example.aped.R;
import org.json.JSONException;
import org.json.JSONObject;
import java.util.ArrayList;
import java.util.List;


public class MainListViewAdapter extends BaseAdapter {

    private MainActivity mainActivity;

    private int image;

    private int favoriteImage;

    public MainListViewAdapter(MainActivity pMainActivity){
        this.mainActivity = pMainActivity;
    }


    @Override
    public int getCount() {
        return mainActivity.xml.getDeviceNames().size();
    }

    @Override
    public Object getItem(final int position) {

        return null;
    }

    @Override
    public long getItemId(final int position) {

        return 0;
    }

    @Override
    public View getView(final int i, View view,
                        final ViewGroup viewGroup) {
        view = mainActivity.getLayoutInflater().inflate(R.layout.listview_layout,
                null);
        TextView textViewName = (TextView) view.findViewById(
                R.id.textName);
        LinearLayout linearLayoutPin = (LinearLayout) view.findViewById(
                R.id.idLinearLayoutPins);
        ImageView buttonViewFavoriten = (ImageView) view.findViewById(
                R.id.imageButtonFavoriten);

        if (mainActivity.favorite.getFavorites().contains(
                mainActivity.xml.getDeviceNames().get(i))) {
            favoriteImage = android.R.drawable.btn_star_big_on;
        } else {
            favoriteImage = android.R.drawable.btn_star_big_off;
        }

        buttonViewFavoriten.setOnClickListener(
                new View.OnClickListener() {
                    @Override
                    public void onClick(final View view) {
                        if (mainActivity.favorite.getFavorites().contains(
                                mainActivity.xml.getDeviceNames().get(i))) {
                            mainActivity.favorite.removeFavorite(
                                    mainActivity.xml.getDeviceNames().get(i));
                            favoriteImage = android.R.drawable.btn_star_big_off;
                            buttonViewFavoriten.setImageResource(
                                    favoriteImage);
                        } else {
                            mainActivity.favorite.addFavorite(
                                    mainActivity.xml.getDeviceNames().get(i));
                            favoriteImage = android.R.drawable.btn_star_big_on;
                            buttonViewFavoriten.setImageResource(
                                    favoriteImage);
                        }
                    }
                });
        //textViewPin.setText(((List<String>) (mainActivity.xml.getPort(mainActivity.xml.getDeviceNames().get(i))).get("pins")).get(0));




        mainActivity.uebergabe.read(mainActivity.xml.getDeviceNames().get(i),
                new Response.Listener<JSONObject>() {
            @Override
            public void onResponse(final JSONObject response) {
                try {
                    JSONObject state = response.getJSONObject("state");
                    List<String> pinValues = new ArrayList<>();
                    for(String pinName: ((List<String>)mainActivity.xml.
                            getPort(mainActivity.xml.getDeviceNames().get(i)).
                            get("pins"))){
                        pinValues.add(state.getString(pinName));
                    }
                    PinView pinView = new PinView(mainActivity,mainActivity.xml.
                            getDeviceNames().get(i), pinValues);
                    for(int j = 0; j < ((List<String>)mainActivity.xml.
                            getPort(mainActivity.xml.getDeviceNames().get(i)).
                            get("pins")).size(); j++) {
                        linearLayoutPin.addView(pinView.getView(j));
                    }
                } catch (JSONException e) {
                                                                // Richtigen log erstellen
                    e.printStackTrace();
                }

            }
        });




        textViewName.setText(mainActivity.xml.getDeviceNames().get(i));
        buttonViewFavoriten.setImageResource(favoriteImage);
        return view;
    }
}
